DROP TABLE DTow_Talk_Dummy;
DROP TABLE DTow_Talk_Child;
DROP TABLE DTow_Talk_Parent1;
DROP TABLE DTow_Type;

CREATE TABLE DTow_Talk_Child(
PKey_ID NUMBER NOT NULL,
FKey1_ID NUMBER,
FKey2_ID NUMBER,
FKey3_ID NUMBER,
FKey4_ID NUMBER,
Date_Col DATE,
Type_ID NUMBER,
Code_Col CHAR(2),
Data_Col VARCHAR2(100))
STORAGE (INITIAL 256M NEXT 256M PCTINCREASE 0);

CREATE UNIQUE INDEX DTow_Talk_Child_UNQ1 ON DTow_Talk_Child(PKey_ID)
STORAGE (INITIAL 256M NEXT 8M PCTINCREASE 0);
CREATE INDEX DTow_Talk_Child_FKey1_ID ON DTow_Talk_Child(FKey1_ID);
CREATE INDEX DTow_Talk_Child_FKey2_ID ON DTow_Talk_Child(FKey2_ID);
CREATE INDEX DTow_Talk_Child_FKey3_ID ON DTow_Talk_Child(FKey3_ID);
CREATE INDEX DTow_Talk_Child_FKey4_ID ON DTow_Talk_Child(FKey4_ID);
CREATE INDEX DTow_Talk_Child_Date_Col ON DTow_Talk_Child(Date_Col);
CREATE INDEX DTow_Talk_Child_Type_ID ON DTow_Talk_Child(Type_ID);
CREATE INDEX DTow_Talk_Child_Code_Col ON DTow_Talk_Child(Code_Col);

CREATE TABLE DTow_Talk_Dummy(X NUMBER);

INSERT INTO DTow_Talk_Dummy VALUES (0);
INSERT INTO DTow_Talk_Dummy VALUES (1);
INSERT INTO DTow_Talk_Dummy VALUES (2);
INSERT INTO DTow_Talk_Dummy VALUES (3);
INSERT INTO DTow_Talk_Dummy VALUES (4);
INSERT INTO DTow_Talk_Dummy VALUES (5);
INSERT INTO DTow_Talk_Dummy VALUES (6);
INSERT INTO DTow_Talk_Dummy VALUES (7);
INSERT INTO DTow_Talk_Dummy VALUES (8);
INSERT INTO DTow_Talk_Dummy VALUES (9);

COMMIT;

INSERT INTO DTow_Talk_Child SELECT /*+ ORDERED */
D1.X*100000+D2.X*10000+D3.X*1000+D4.X*100+D5.X*10+D6.X,
D1.X*10000+D2.X*1000+D3.X*100+D4.X*10+D5.X,
TRUNC((D1.X*10000+D2.X*1000+D3.X*100+D4.X*10+D5.X)/2),
TRUNC((D1.X*10000+D2.X*1000+D3.X*100+D4.X*10+D5.X)/4),
TRUNC((D2.X*10000+D3.X*1000+D4.X*100+D5.X*10+D6.X)/8),
TO_DATE('01/01/2005','MM/DD/YYYY')- (1000-(D1.X*100+D2.X*10+D3.X)),
DECODE((D4.X*100+D5.X*10+D6.X),0,1,1,2,2,2,3,2,4,2,5,2,3),
DECODE(D1.X,9,
       DECODE(D5.X*10+D6.X,49,'OP',
              DECODE(D2.X,9,
                     DECODE(D6.X,3,'OP',6,'OP',9,'OP',
                            DECODE(D3.X,9,'OP','CL'))
                     )
              )
       ),
'ABCDEFGHIJABCDEFGHIJABCDEFGHIJABCDEFGHIJABCDEFGHIJ'||
'ABCDEFGHIJABCDEFGHIJABCDEFGHIJ' /* 80 CHARS */
FROM /* Deliberate Cartesian product to generate rows */
DTow_Talk_Dummy D1, DTow_Talk_Dummy D2, DTow_Talk_Dummy D3,
DTow_Talk_Dummy D4, DTow_Talk_Dummy D5, DTow_Talk_Dummy D6;

COMMIT;

CREATE TABLE DTow_Talk_Parent1(
PKey_ID NUMBER NOT NULL,
FKey1_ID NUMBER,
FKey2_ID NUMBER,
FKey3_ID NUMBER,
FKey4_ID NUMBER,
Date_Col DATE,
Type_ID NUMBER,
Code_Col CHAR(2),
Data_Col VARCHAR2(100));

CREATE UNIQUE INDEX DTow_Talk_Parent1_UNQ1 ON DTow_Talk_Parent1(PKey_ID);

INSERT INTO DTow_Talk_Parent1 SELECT /*+ ORDERED */
D1.X*10000+D2.X*1000+D3.X*100+D4.X*10+D5.X,
D1.X*1000+D2.X*100+D3.X*10+D4.X,
TRUNC((D1.X*1000+D2.X*100+D3.X*10+D4.X)/2),
TRUNC((D1.X*1000+D2.X*100+D3.X*10+D4.X)/4),
TRUNC((D2.X*1000+D3.X*100+D4.X*10+D5.X)/8),
TO_DATE('01/01/2005','MM/DD/YYYY')- (1000-D1.X*100+D2.X*10+D3.X),
DECODE((D3.X*100+D4.X*10+D5.X),0,1,1,2,2,2,3,2,4,2,5,2,3),
DECODE(D1.X,9,
       DECODE(D4.X*10+D5.X,49,'OP',
              DECODE(D2.X,9,
                     DECODE(D5.X,3,'OP',6,'OP',9,'CL',
                            DECODE(D3.X,9,'OP','CL'))
                     )
              )
       ),
'ABCDEFGHIJABCDEFGHIJABCDEFGHIJABCDEFGHIJABCDEFGHIJ'||
'ABCDEFGHIJABCDEFGHIJABCDEFGHIJ' /* 80 CHARS */
FROM /* Deliberate Cartesian product to generate rows */
DTow_Talk_Dummy D1, DTow_Talk_Dummy D2, DTow_Talk_Dummy D3,
DTow_Talk_Dummy D4, DTow_Talk_Dummy D5;

ANALYZE TABLE DTow_Talk_Child COMPUTE STATISTICS;
ANALYZE TABLE DTow_Talk_Parent1 COMPUTE STATISTICS;
ANALYZE TABLE DTow_Talk_Child COMPUTE STATISTICS
        FOR COLUMNS Type_ID SIZE 254, Code_Col SIZE 254;
ANALYZE TABLE DTow_Talk_Parent1 COMPUTE STATISTICS
        FOR COLUMNS Type_ID SIZE 254, Code_Col SIZE 254;

CREATE TABLE DTow_Type(Type_ID NUMBER, Description VARCHAR2(20));

INSERT INTO DTow_Type VALUES(1,'VERY_RARE');
INSERT INTO DTow_Type VALUES(2,'RARE');
INSERT INTO DTow_Type VALUES(3,'COMMON');

COMMIT;

CREATE UNIQUE INDEX DTow_Type_UNQ1 on DTow_Type(Type_ID);
CREATE INDEX DTow_Type_Description on DTow_Type(Description);

ANALYZE TABLE DTow_Type COMPUTE STATISTICS;
DROP TABLE DTow_Talk_Generic;

CREATE TABLE DTow_Talk_Generic(
PKey_ID NUMBER NOT NULL,
Generic01 VARCHAR(50),
Generic02 VARCHAR(50),
Generic03 VARCHAR(50),
Generic04 VARCHAR(50),
Generic05 VARCHAR(50),
Data_Col VARCHAR2(100))
STORAGE (INITIAL 256M NEXT 256M PCTINCREASE 0 MINEXTENTS 1);

CREATE UNIQUE INDEX DTow_Talk_Generic_UNQ1 ON DTow_Talk_Generic(PKey_ID)
STORAGE (INITIAL 256M NEXT 8M PCTINCREASE 0);
CREATE INDEX DTow_Talk_Generic_Generic01 ON DTow_Talk_Generic(Generic01)
STORAGE (INITIAL 256M NEXT 8M PCTINCREASE 0);

INSERT INTO DTow_Talk_Generic SELECT /*+ ORDERED */
D1.X*100000+D2.X*10000+D3.X*1000+D4.X*100+D5.X*10+D6.X+1000000,
TO_CHAR(D1.X*100000+D2.X*10000+D3.X*1000+D4.X*100+D5.X*10+D6.X),
NULL,
NULL,
NULL,
NULL,
'ABCDEFGHIJABCDEFGHIJABCDEFGHIJABCDEFGHIJABCDEFGHIJ'||
'ABCDEFGHIJABCDEFGHIJABCDEFGHIJ' /* 80 CHARS */
FROM /* Deliberate Cartesian product to generate rows */
DTow_Talk_Dummy D1, DTow_Talk_Dummy D2, DTow_Talk_Dummy D3,
DTow_Talk_Dummy D4, DTow_Talk_Dummy D5, DTow_Talk_Dummy D6;

COMMIT;

ANALYZE TABLE DTow_Talk_Generic COMPUTE STATISTICS;
